' module: diagram of the learning progress

namespace DIAGRAM
  declare function callback(exercise as TExercise) as long
end namespace

globalOptions.add(TExercise("diagram", localize("diagramTitle"), "full", 0, @DIAGRAM.callback, 0, 0))

function DIAGRAM.callback(exercise as TExercise) as long
  enum
    posHelp = 1, posRepeat, posProgress, posBack
  end enum
  static as integer setting = posRepeat
  dim as string key
  dim as integer pos1X = 100, pos2X = 500, pos1Y = 100, pos2Y = 300, w = 200, h = 100
  dim as integer LBx = 120, LBy = 580, LBw = 150, LBh = 30, LBp = 20
  dim as integer maxEntries = 100, tempInt
  dim as TExercise ex1 = getExercise(LANGSHORT1 & "-" & LANGSHORT2), _
                   ex2 = getExercise(LANGSHORT2 & "-" & LANGSHORT1)
  if len(ex1.id) = 0 then return RETVAR.generalError

  dim as TList ptr listPtr
  dim tempList as TList, lp as TListPoint, word as TWord
  cls

  dim diaGui as TGui, event as TGuiEvent
  diaGui.addElement _
      TGuiElement(GuiElementType.button, posHelp, _
      exepath & "/img/help.bmp", LBx-60, LBy-5, 40, 40, chr(255, 59),, "", GuiState.noBorder)
  dim as TGuiElement buttonRepeat   = _
      TGuiElement(GuiElementType.button, posRepeat, LBx, LBy, LBw, LBh, "nächste Wiederholung")
  dim as TGuiElement buttonProgress = _
      TGuiElement(GuiElementType.button, posProgress, LBx+(LBw+LBp), LBy, LBw, LBh, "Gesamtfortschritt")
  select case setting
    case posRepeat   : buttonRepeat.state   = GuiState.activated
    case posProgress : buttonProgress.state = GuiState.activated
  end select
  diaGui.addElement buttonRepeat
  diaGui.addElement buttonProgress
  diaGui.addElement _
      TGuiElement(GuiElementType.button, posBack, LBx+(LBw+LBp)*3, LBy, LBw, LBh, "zurück")
  diaGui.show

  centerFT SCREEN_X\2, 50, "Lernfortschritt", font, 20

  printFT pos1X, pos1Y+h+20, LANGTITLE1 & " -> " & LANGTITLE2 & ", " & localize("currentList"), font, 12
  printFT pos1X, pos1Y+h+35, "(" & ex1.currentList.list.size & " von " & exercise.fullList.size _
                           & " Wörtern)", font, 12
  printFT pos2X, pos1Y+h+20, LANGTITLE2 & " -> " & LANGTITLE1 & ", " & localize("currentList"), font, 12
  printFT pos2X, pos1Y+h+35, "(" & ex2.currentList.list.size & " von " & exercise.fullList.size _
                           & " Wörtern)", font, 12
  printFT pos1X, pos2Y+h+20, LANGTITLE1 & " -> " & LANGTITLE2 & ", " & localize("allWords"), font, 12
  printFT pos2X, pos2Y+h+20, LANGTITLE2 & " -> " & LANGTITLE1 & ", " & localize("allWords"), font, 12
  dim as TTextBlock textBlock
  textBlock.add 700, localize("diagramDesc"), font, 14
  dim as FB.Image ptr textImg = textBlock.show
  if textImg <> 0 then put (50, 480), textImg, pset
  do
    dim as integer count(3, maxEntries-1), maxHeight = 0
    for i as integer = 0 to 3
      ' read list
      tempInt = 0
      select case i
        case 0 : listPtr = @ex1.currentList
        case 1 : listPtr = @ex2.currentList
        case 2 : listPtr = @ex1.fullList
        case 3 : listPtr = @ex2.fullList
      end select
      for k as integer = 0 to listPtr->list.size-1
        lp = listPtr->list.get(k)
        select case setting
          case posRepeat
            tempInt = int((lp.position - now)^.78) + 1
          case posProgress
            word = globallist.get(lp.id)
            tempInt = iif(i mod 2, word.levelB, word.levelA)
        end select
        if tempInt < 0 then tempInt = 0
        if tempInt >= maxEntries then tempInt = maxEntries-1
        count(i, tempInt) += 1
        if maxHeight < count(i, tempInt) then maxHeight = count(i, tempInt)
      next
      ' show diagrams
      dim as integer x = iif(i mod 2, pos2X, pos1X), y = iif(i > 1, pos2Y, pos1Y)
      dim as single dx = w / maxEntries, dy = h / iif(maxHeight > 0, maxHeight, 1)
      dim as TCoord coord = FTSize(maxHeight & "  ", font, 10)
      dim as integer legendX1 = x - coord.x, legendY1 = y - coord.y\2
      dim as integer legendX2 = x - FTSize("0  ", font, 10).x
      screenlock
      line (legendX1, legendY1)-(x+w, y+h), &hffffff, bf
      printFT legendX1, legendY1, str(maxHeight), font, 10
      printFT legendX2, legendY1+h, "0", font, 10
      line (x, y)-step(0, h)
      line -step(w, 0)
      for k as integer = 0 to maxEntries-1
        line (x + dx*k, y + h)-step(dx, -dy*count(i, k)), &h7f7f7f, bf
      next
      screenunlock
    next

    do
      sleep 1
      key = inkey
      event = diaGui.getEvent(key)
      if key = chr(27) or key = chr(255, 107) then exit do, do
    loop until event.id
    select case event.id
      case posHelp
        tempInt = showHelpScreen(MODULE_PATH & "doc.htm", "diagram")
        if tempInt = RETVAR.windowClosed then key = chr(255, 107) : exit do
      case posRepeat
        buttonRepeat.state   = GuiState.activated
        buttonProgress.state = GuiState.active
        setting = posRepeat
        diaGui.setElement buttonRepeat
        diaGui.setElement buttonProgress
        screenlock
        buttonRepeat.show
        buttonProgress.show
        screenunlock
      case posProgress
        buttonRepeat.state   = GuiState.active
        buttonProgress.state = GuiState.activated
        setting = posProgress
        diaGui.setElement buttonRepeat
        diaGui.setElement buttonProgress
        screenlock
        buttonRepeat.show
        buttonProgress.show
        screenunlock
    end select
  loop until event.id = posBack
  imagedestroy textImg
  return iif(key = chr(255, 107), RETVAR.windowClosed, RETVAR.ok)
end function
