' module: edit words
#include once "include/showWords.bi"

namespace EDITWORDS
  declare function callback(exercise as TExercise) as long
  declare sub edit(id as integer)
  declare function outp(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, optional as integer) as integer
  declare function search(list as mdList(TListPoint), srh as string, srchOpt as integer) as mdList(TListPoint)
  declare function settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
  enum SORT
    word = 1, translate, id, diffWord, diffTrans, mark
    last
  end enum
  namespace OPT
    const word = 1, translate = 2, flexion = 4, keyword = 8, lazy = 16
  end namespace
end namespace

function EDITWORDS.callback(exercise as TExercise) as long
  if (GlobalSettings and GLOBAL_SETTINGS.ALLOW_EDITS) = 0 then return 0
  static as integer sorted = 0, searchOpt = 3, spec = 0
  static as string searchString
  dim as integer index, count, mx, my, mb, mw, wheel, wheelNew
  dim as integer tempInt, page = 0, direction = 1
  dim as uinteger col
  dim as string tempstring, key
  dim as TWord word
  redim as string keyArray(exercise.fullList.size-1)
  redim as TListPoint lpArray(exercise.fullList.size-1)
  enum
    posNone   = 0, posSetting, posHelp, posUp, posDown, posBack
    posSearch = 10   ' leave space for search options
    posSort   = 20   ' leave space for sort options
  end enum

  if sorted = 0 then
    cls
    listToArray exercise.fullList, "id", keyArray(), lpArray()
    quickSort keyArray(), lpArray()
    arrayToList exercise.fullList, lpArray()
    exercise.fullList.save
    exercise.currentList.list.clear
    dim as mdList(TListPoint) tempList
    tempList = search(exercise.fullList.list, searchString, searchOpt)
    exercise.currentList.list.addAll(templist)
    tempList.clear
    sorted = SORT.id
  elseif searchString = "" then
    exercise.currentList.list.addAll(exercise.fullList.list)
  end if
  count = exercise.fullList.size

  dim as integer LBx = 0, LBy = 590, LBw = 140, LBh = 30, LBpx = 20
  dim as integer SBx = 650, SBy = 50, SBw = 120, SBh = 30, SBp = 15
  dim dictGui as TGui, event as TGuiEvent
  dim as string buttonSearchInfo(1 to ...) = { "spanisch", "deutsch", "Flexion", "Schlüsselwörter", "großzügig" }
  dim as TGuiElement buttonSearch(1 to ubound(buttonSearchInfo)) 
  dictGui.addElement _
      TGuiElement(GuiElementType.button, possort+SORT.word, _
                  LBx+LBw+LBpx, LBy, LBw, LBh, "Wort spanisch", chr(255, 61))
  dictGui.addElement _
      TGuiElement(GuiElementType.button, possort+SORT.translate, _
                  LBx+2*(LBw+LBpx), LBy, LBw, LBh, "Wort deutsch", chr(255, 62))
  dictGui.addElement _
      TGuiElement(GuiElementType.button, possort+SORT.id, _
                  LBx+3*(LBw+LBpx), LBy, LBw, LBh, "nach Lektion", chr(255, 63))
  dictGui.addElement _
      TGuiElement(GuiElementType.button, posBack, _
                  LBx+4*(LBw+LBpx), LBy, LBw, LBh, "zurück", chr(27))
  dictGui.addElement _
      TGuiElement(GuiElementType.button, posSearch, _
                  SBx, SBy, SBw, SBh, "Suche", chr(255, 60))
  dim as TGuiElement buttonUp   = TGuiElement(GuiElementType.button, posUp, _
                                  exepath & "/img/up.bmp", LBx+30, LBy, 31, 30, chr(255, 73))
  dim as TGuiElement buttondown = TGuiElement(GuiElementType.button, posUp, _
                                  exepath & "/img/down.bmp", LBx+70, LBy, 31, 30, chr(255, 81))
  dictGui.addElement buttonUp
  dictGui.addElement buttonDown
  for i as integer = 1 to ubound(buttonSearch)
    buttonSearch(i) = TGuiElement(GuiElementType.button, posSearch+i, _
                      SBx, SBy+(i+1)*(SBh+SBp), SBw, SBh, buttonSearchInfo(i))
    if bit(searchOpt, i-1) then buttonSearch(i).state or= GuiState.activated
    dictGui.addElement buttonSearch(i)
  next

  ' show words
  dim as TPages pages = TPages(13, 40, 15, 15, 10, 180, 550, 550, 1)
  dim as TGuiElement tempButton
  pages.outp = @outp
  pages.colWidth = pages.colDist
  pages.calcPositions(exercise.currentList.list)
  page = 0
  do
    pages.barPos = 0
    screenlock
    cls
    line (0, 0)-step(SCREEN_X-1, LBy-1), &hffffff, bf
    pages.printEntries(exercise.currentList.list, page)
    ' show arrow buttons or not?
    if pages.pages.size = 1 then
      ' hide if only one page is shown
      if buttonUp.state <> GuiState.hidden then
        buttonUp.state = GuiState.hidden
        dictGui.setElement(buttonUp)
      end if
      if buttonDown.state <> GuiState.hidden then
        buttonDown.state = GuiState.hidden
        dictGui.setElement(tempButton)
      end if
    else
      if page = 0 then
        ' deactivate "up"
        if buttonUp.state <> GuiState.deactivated then
          buttonUp.state = GuiState.deactivated
          dictGui.setElement(buttonUp)
        end if
      else
        ' activate "up"
        if buttonUp.state <> GuiState.active then
          buttonUp.state = GuiState.active
          dictGui.setElement(buttonUp)
        end if
      end if
      if page = pages.pages.size-1 then
        ' deactivate "down"
        if buttonDown.state <> GuiState.deactivated then
          buttonDown.state = GuiState.deactivated
          dictGui.setElement(buttonDown)
        end if
      else
        ' activate "down"
        if buttonDown.state <> GuiState.active then
          buttonDown.state = GuiState.active
          dictGui.setElement(buttonDown)
        end if
      end if
    end if
    tempButton = dictGui.getElement(posSort+sorted)
    tempButton.state = GuiState.activated
    dictGui.setElement(tempButton)
    dictGui.show
    if len(searchString) < 15 then
      centerFT SBx+SBw\2, SBy+2*SBh, searchString, font, 12
    else
      centerFT SBx+SBw\2, SBy+2*SBh, left(searchString, 12) & "...", font, 12
    end if
    screenunlock
    do
      getmouse mx, my, wheel, mb
      sleep 1
    loop until mb < 1
    ' user input
    do
      key = inkey
      event = dictGui.getEvent(key)
      ' edit existing word
      getmouse mx, my, wheelNew, mb
      if mb = 1 orelse mb = 2 then
        for i as integer = 0 to ubound(pages.wordPos)
          with pages.wordPos(i)
            if checkMouseIn(.x, .y-pages.wordDist\2, pages.colDist\2, .h+pages.wordDist) <> 0 then
              if mb = 1 then
                ' edit word
                dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                edit .id
                put (0, 0), tempImg, pset
                imagedestroy tempImg
                exit for
              elseif mb = 2 then
                ' show info
                dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                wordInfo globallist.get(.id)
                put (0, 0), tempImg, pset
                imagedestroy tempImg
                exit for
              end if
            end if
          end with
        next
        do
          getmouse mx, my, wheel, mb
          sleep 1
        loop until mb < 1
      end if
      ' mouse wheel
      if mx >= 0 then
        if wheelNew > wheel then
          event.id = posUp
        elseif wheelNew < wheel then
          event.id = posDown
        end if
        wheel = wheelNew
      end if
      ' GUI buttons
      select case as const event.id
        case posUp
          if page > 0 then
            page -= 1
            exit do
          end if
        case posDown
          if page < pages.pages.size-1 then
            page += 1
            exit do
          end if
        case posHelp
          dim as integer ret = showHelpScreen(MODULE_PATH & "doc.htm", "editWords")
          if ret = RETVAR.windowClosed then key = chr(255, 107)
        case posSetting
          ' TODO
          'chooseWords(exercise)
          'list.clear
          'if exercise.currentList.size then
          '  list.addAll(exercise.currentList.list)
          '  count = exercise.currentlist.size
          'else
          '  list.addAll(exercise.fullList.list)
          '  count = exercise.fulllist.size
          'end if
          'pages.calcPositions(list)
          'page = 0
          'exit do
        case posSearch
          dim as string tempString = searchInput
          if tempString = chr(255, 107) then key = tempString : exit do
          if tempString <> searchString and tempString <> chr(27) then
            searchString = tempString
            exercise.currentList.list.clear
            dim as mdList(TListPoint) tempList
            tempList = search(exercise.fullList.list, searchString, searchOpt)
            exercise.currentList.list.addAll(tempList)
            tempList.clear
            pages.calcPositions(exercise.currentList.list)
            page = 0
            exit do
          end if
        case posSearch+1 to posSearch+ubound(buttonSearch)
          buttonSearch(event.id-posSearch).state xor= GuiState.activated
          if bit(searchOpt, event.id-posSearch-1) then
            searchOpt = bitreset(searchOpt, event.id-posSearch-1)
          else
            searchOpt = bitset(searchOpt, event.id-posSearch-1)
          end if
          dictGui.setElement buttonSearch(event.id-posSearch)
          buttonSearch(event.id-posSearch).show
          exercise.currentList.list.clear
          dim as mdList(TListPoint) tempList
          tempList = search(exercise.fullList.list, searchString, searchOpt)
          exercise.currentList.list.addAll(tempList)
          tempList.clear
          pages.calcPositions(exercise.currentList.list)
          page = 0
          exit do
        case posSort+1 to posSort+SORT.last-1
          if sorted = event.id - posSort then direction *= -1 else direction = 1
          tempButton = dictGui.getElement(posSort+sorted)
          tempButton.state = GuiState.active
          dictGui.setElement(tempButton)
          tempButton.show
          sorted = event.id - posSort
          tempButton = dictGui.getElement(event.id)
          tempButton.state = GuiState.activated
          dictGui.setElement(tempButton)
          tempButton.show
          select case event.id-posSort
            case SORT.word      : tempString = "word"
            case SORT.translate : tempString = "trans"
            case SORT.id        : tempString = "id"
            case SORT.diffWord  : tempString = "levelA"
            case SORT.diffTrans : tempString = "levelB"
            case SORT.mark      : tempString = "mark"
          end select
          listToArray exercise.fullList, tempString, keyArray(), lpArray()
          quickSort keyArray(), lpArray(), direction
          arrayToList exercise.fullList, lpArray()
          exercise.currentList.list.clear
          dim as mdList(TListPoint) tempList
          tempList = search(exercise.fullList.list, searchString, searchOpt)
          exercise.currentList.list.addAll(templist)
          tempList.clear
          pages.calcPositions(exercise.currentList.list)
          page = 0
          exit do
        case posBack
          exit do, do
      end select
      sleep 1
    loop until key = chr(255, 107)
  loop until key = chr(27) or key = chr(255, 107)
  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function

sub EDITWORDS.edit(id as integer)
  if (GlobalSettings and GLOBAL_SETTINGS.ALLOW_EDITS) = 0 then exit sub
  dim as TWord w = globallist.get(id)
  dim as TInput inpArr(99)
  dim as integer countInp = 5, fSize = FONTSIZE.SMALL, position = 0
  dim as string translateString, tagString, keyArr(any), key
  dim gui as TGui, event as TGuiEvent
  wordToArray SPECIAL_KEYS, keyArr(), 0

  cls
  printFT  50,  50, "ID " & format(w.id, "## ### ### ###"), font, fSize, &h7f7f7f
  printFT  50,  80, "Wort (" & LANGTITLE1 & "):", font, fSize
  printFT  50, 110, "Tag-Liste:", font, fSize
  printFT  50, 140, "Übersetzung(en) (" & LANGTITLE2 & "):", font, fSize

  inpArr(0) = TInput(250, 50, fSize, "Kapitel ", str(w.lession), 4,, "0", "0123456789")
  inpArr(1) = TInput(400, 50, fSize, "Word Nr. ", str(w.lessionPos), 3,, "0", "0123456789")
  inpArr(2) = TInput(250, 80, fSize, "", w.word, MAX_WORDLENGTH,, "(leer)")
  tagString = w.tag.get(0)
  for i as integer = 1 to w.tag.size-1
    tagString &= ";" & w.tag.get(i)
  next
  inpArr(3) = TInput(250, 110, fSize, "", tagString, MAX_WORDLENGTH,, "(leer)")
  translateString = w.translate.get(0)
  for i as integer = 1 to w.translate.size-1
    translateString &= ";" & w.translate.get(i)
  next
  inpArr(4) = TInput(80, 160, fSize, "", translateString, MAX_WORDLENGTH)
  inpArr(0).show
  for i as integer = 1 to countInp-1
    inpArr(i).show(0)
  next

  do
    key = inkey
    massInput(inpArr(), key, -1, 0, keyArr(), position, countInp-1)
  loop until key = chr(27)
end sub

function EDITWORDS.outp(x as integer, y as integer, x2 as integer, h as integer, _
                         word as TWord, optional as integer) as integer
  dim as integer col, tags = word.tag.size, ret = word.translate.size - (tags > 0)
  dim as string tempString, irr = replace(word.map.get("irr"), "→", "->")
  if len(irr) and ret = 1 then ret = 2
  if optional mod 32 then
    select case word.map.get("genus")
      case "m"  : col = &hff
      case "f"  : col = &hff0000
      case else : col = 0
    end select
    printFT x, y, word.word, font, optional mod 32, col
    if len(irr) then
      printFT x, y+15, "  (" & irr & ")", font, optional mod 32
      if optional mod 32 then
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/attention.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
      end if
    end if
    for i as integer = 0 to word.translate.size-1
      printFT x2, y+i*15, word.translate.get(i), font, optional mod 32
    next
    if tags > 0 then
      tempString = iif(tags = 1, "Tag", "Tags") & ": " & word.tag.get(0)
      for i as integer = 1 to tags - 1
        tempString &= ", " & word.tag.get(i)
      next
      printFT x+30, y+word.translate.size*15, tempString, font, optional mod 32
    end if
    printFT 2*x2-x, y, "Lektion " & word.lession\100 & "." & (word.lession mod 100) _
                       & " / " & word.lessionPos, font, optional mod 32
    select case word.groupname
      case "verb"      : printFT 2*x2-x+140, y, "Verb", font, optional mod 32
      case "noun"      : printFT 2*x2-x+140, y, "Nomen", font, optional mod 32
      case "adjective" : printFT 2*x2-x+140, y, "Adjektiv", font, optional mod 32
      case "adverb"    : printFT 2*x2-x+140, y, "Adverb", font, optional mod 32
      case "pronoun"   : printFT 2*x2-x+140, y, "Pronomen", font, optional mod 32
      case else        : printFT 2*x2-x+140, y, "sonstiges", font, optional mod 32
    end select
  end if
  return ret*h
end function

function EDITWORDS.search(list as mdList(TListPoint), srh as string, srchOpt as integer) as mdList(TListPoint)
  dim as integer i, size = list.size*list.size-1
  dim as TListPoint lp1
  dim as TWord w
  dim as mdList(TListPoint) ret
  dim as integer found, modParam = MODIFY_SEARCH_SIMPLE
  dim as string tempString, word, srch = iif(srchOpt and OPT.lazy, modifyTxt(srh, modParam), srh)
  dim as integer msgW = 200, msgH = 80, msgX = (SCREEN_X-msgw)\2, msgY = (SCREEN_Y-msgH)\2
  if len(srh) andalso srchOpt and OPT.flexion then messageWait localize("searching")
  foreach(TListPoint, lp1, list)
    w = globallist.get(lp1.id)
    if len(srch) then
      word = iif(srchOpt and OPT.lazy, modifyTxt(w.word, modParam), w.word)
      found = 0
      if srchOpt and OPT.word then
        if instr(word, srch) then found = -1
      end if
      if found = 0 andalso srchOpt and OPT.translate then
        for i as integer = 0 to w.translate.size-1
          tempString = iif(srchOpt and OPT.lazy, modifyTxt(w.translate.get(i)), w.translate.get(i))
          if instr(tempString, srch) then found = -1 : exit for
        next
      end if
      if found = 0 andalso srchOpt and OPT.flexion then
        for i as integer = 0 to flexionCount(w, INFLECT.FULL)
          tempString = iif(srchOpt and OPT.lazy, modifyTxt(flexionLang1(w, i).word), flexionLang1(w, i).word)
          if instr(tempString, srch) then found = -1 : exit for
        next
      end if
      if found = 0 andalso srchOpt and OPT.keyword then
        foreach(string, tempString, w.tag)
          if srchOpt and OPT.lazy then tempString = modifyTxt(tempString)
          if instr(tempString, srch) then found = -1 : exit while
        nexteach
        if found = 0 then
          dim as mdList(string) ks = w.map.keySet
          foreach(string, tempString, ks)
            tempString = w.map.get(tempString)
            if srchOpt and OPT.lazy then tempString = modifyTxt(tempString)
            if instr(tempString, srch) then found = -1 : exit while
          nexteach
        end if
      end if
      if found = 0 then continue while
    end if
    if w.word = "" then continue while
    ret.add(lp1)
  nexteach
  if len(srh) andalso srchOpt and OPT.flexion then messageWait
  return ret
end function

function EDITWORDS.settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
  if (GlobalSettings and GLOBAL_SETTINGS.ALLOW_EDITS) = 0 then return 0
  return 0
end function
