function levenshteinDistance(s1 as string, s2 as string) as integer
  dim as integer ret = 0, l1 = len(s1), l2 = len(s2), i, k
  dim as integer lev(l1, l2)
  lev(0, 0) = 0
  for i=0 To l1
    lev(i, 0) = i
  next
  for k=1 To l2
    lev(0, k) = k
  next
  for i=1 To l1
    for k=1 to l2
      if s1[i-1] = s2[k-1] then
        lev(i, k) = lev(i-1, k-1)
      else
        lev(i, k) = lev(i-1, k-1) + 1
      end if
      if lev(i, k-1) < lev(i, k) then
        lev(i, k) = lev(i, k-1) + 1
      end if
      if lev(i-1, k) < lev(i, k) then
        lev(i, k) = lev(i-1, k) + 1
      end if
      if i > 1 and k > 1 andalso s1[i-2] = s2[k-1] and s1[i-1] = s2[k-2] then
        if lev(i-2, k-2) < lev(i, k) then
          lev(i, k) = lev(i-2, k-2) + 1
        end if
      end if
    next
  next
	return lev(l1, l2)
end function

function levenshtein(w as TWord, list as TList) as TList
  dim as integer lev, i
  dim as string s1, s2
  dim as TWord w2
  dim as TListPoint listPoint, l
  dim as TList ret
  foreach(TListPoint, listPoint, list.list)
    w2 = globallist.get(listPoint.id)
    listPoint.position = levenshteinDistance(w.word, w2.word)
    foreach(string, s1, w.translate)
      foreach(string, s2, w2.translate)
        lev = levenshteinDistance(s1, s2)
        if listPoint.position > lev then listPoint.position = lev
      nexteach
    nexteach
    i = 0
    foreach(TListPoint, l, ret.list)
      if l.position > listPoint.position then
        ret.list.add(i, listPoint)
        continue while, while
      end if
      i += 1
    nexteach
    ret.list.add(listPoint)
  nexteach    
  return ret
end function
