sub WORDTEST.incGui(gui as TGui, wdata as TData)
  wdata.letterX     = 220
  wdata.letterY     = 240
  wdata.letterDist  = 30
  wdata.letterDistY = 30
  wdata.letterSize  = 13
  wdata.inpX = 100
  wdata.inpY = 110
  wdata.inpW = SCREEN_X - 2*wdata.inpX

  ' special keys and levels of difficulty
  guiAddKeys gui, wdata.posKeys, wdata.keyString(), 40, 330, 30, 30, 15, 15, 14
  guiAddLevs gui, wdata.posLevels, 40, 450, 100, 40, 20
  ' buttons: list of letters
  gui.addElement TGuiElement(GuiElementType.button, wdata.posLetters, 40, wdata.letterY, 160, 25, localize("usedLetters"))  
  for i as integer = 0 to (MAX_WORDLENGTH-1)\2
    gui.addElement TGuiElement(GuiElementType.button, wdata.posLetters+i+1, wdata.letterX+i*wdata.letterDist, wdata.letterY, _
                    wdata.letterDist, wdata.letterSize*2, "",,,, GuiState.noBorder)  
    gui.addElement TGuiElement(GuiElementType.button, wdata.posLetters+(MAX_WORDLENGTH-1)\2+i+2, _
                    wdata.letterX+i*wdata.letterDist, wdata.letterY+wdata.letterDistY, _
                    wdata.letterDist, wdata.letterSize*2, "",,,, GuiState.noBorder)  
  next
  ' button: repeat question
  dim as TGuiElement tempButton
  tempButton = TGuiElement(GuiElementType.button, wdata.posRepeat, 60, 530, 120, 50, localize("repeat"), chr(9),, "Tab")
  tempButton.fontsize = 16
  gui.addElement tempButton
  ' button: show hint
  tempButton = TGuiElement(GuiElementType.button, wdata.posHint, 620, 530, 120, 50, localize("hint"))
  tempButton.fontsize = 16
  gui.addElement tempButton
  ' button: show correct answer
  tempButton = TGuiElement(GuiElementType.button, wdata.posShow, 330, 530, 120, 50, localize("show"), chr(13),, "Enter")
  tempButton.fontsize = 16
  gui.addElement tempButton
  ' button: speak word
  gui.addElement _
      TGuiElement(GuiElementType.button, wdata.posSpeak, _
                  exepath & "/img/speaker.bmp", 700, 370, 40, 40, chr(255, 60),, "F2", _
                  GuiState.noBorder or GuiState.deactivated)
  ' button: show program help
  gui.addElement _
      TGuiElement(GuiElementType.button, wdata.posHelp, _
                  exepath & "/img/help.bmp", 700, 310, 40, 40, chr(255, 59),, "F1", GuiState.noBorder)
  gui.addElement _
      TGuiElement(GuiElementType.button, wdata.posInfo, _
                  exepath & "/img/info.bmp", 50, 80, 24, 24,,,, GuiState.noBorder)
  if GlobalSettings and GLOBAL_SETTINGS.ALLOW_EDITS then
    gui.addElement TGuiElement(GuiElementType.button, wdata.posEdit, _
                   exepath & "/img/edit.bmp", 50, 130, 24, 24,,,, GuiState.noBorder)
  end if
end sub

sub SEARCHDIALOG.incGui(gui as TGui, sdata as TData)
  sdata.w    = 640
  sdata.h    = 300
  sdata.inpX = 30
  sdata.inpY = 40
  sdata.inpW = sdata.w - 3*sdata.inpX
  gui.addElement TGuiElement(GuiElementType.button, sdata.posOk, _
                 SCREEN_X\2-170, SCREEN_Y\2+80, 150, 30, localize("ok"), chr(13))
  gui.addElement TGuiElement(GuiElementType.button, sdata.posExit, _
                 SCREEN_X\2+20,  SCREEN_Y\2+80, 150, 30, localize("abort"), chr(27))
  guiAddKeys gui, sdata.posKeys, sdata.keyString(), (SCREEN_X-sdata.w)\2+30, (SCREEN_Y-sdata.h)\2+110, 30, 30, 12, 15, 14
end sub

